#include <gb/gb.h>
#include <stdio.h>
#include "title.h"

// Tilemap
extern const unsigned char title_map[18][20];
extern const unsigned char title_tiles[2400/2];
// Palette fade table
static const unsigned char palette_table[7] = {
	0xE4,
	0xA4,
	0x94,
	0x90,
	0x50,
	0x40,
	0x00,
};

void title() {
	UINT8 lastKeys = joypad();
	UINT8 counter = 0;
	UINT8 fadeCounter = 6;
	UINT8 fadingOut = 0;
	DISPLAY_OFF;
	// Copy title tilemap
	set_bkg_data(0, 75, title_tiles);
	set_bkg_tiles(0, 0, 20, 18, title_map);
	set_bkg_tiles(0, 11, 20, 1, title_map[12]);
	// Configure LCD
	LCDC_REG = BITS(1, 0, 0, 0, 0, 0, 0, 1);
	BGP_REG = palette_table[fadeCounter];
	SCX_REG = SCY_REG = 0;
	// Move sprites offscreen to avoid rests of the previous play
	for (counter = 0; counter < 40; counter++)
		move_sprite(counter, 0, 0);
	DISPLAY_ON;
	while (1) {
		UINT8 remainder = counter & 63, remainder2 = counter & 7;
		UINT8 keys = joypad();
		UINT8 keysPressed = keys & ~lastKeys;
		lastKeys = keys;
		// Start fade out procedure on start button
		if (keysPressed & J_START)
			fadingOut = 1;
		wait_vbl_done();
		counter++;
		// Every 8 frames, fade one step to the destination (0 first, 7 in fade out)
		if (remainder2 == 7) {
			if (fadingOut) {
				fadeCounter = fadeCounter + 1;
				// Faded out entirely
				if (fadeCounter == 7)
					break;
			}
			else if (fadeCounter > 0)
				fadeCounter = fadeCounter - 1;
			BGP_REG = palette_table[fadeCounter];
		}
		// Blink the PRESS START by replacing the tiles
		if (fadeCounter == 0 || fadingOut) {
			if (remainder == 32)
				set_bkg_tiles(0, 11, 20, 1, title_map[12]);
			else if (remainder == 0)
				set_bkg_tiles(0, 11, 20, 1, title_map[11]);
		}
	}
}
